/*
 * GlobalVariables.c
 *
 * Author    : Najath Abdul Azeez
 * Copyright : http://opelex.net
 * License   : See LICENSE file
 *
 */
//
// TITLE:   Global Variables Declaration & Initialization.
//

#include "F2806x_Device.h"     // Include F2806x Header files
#include "macros.h"            // Include macro definitions
#include "GlobalVariables.h"   // Include Global Variable declarations

// Global variables used in this example

// Frequency and angles
Int16   freq, freq_set;
Int32   freq_state;
Uint32  thetaState;
Uint16  theta, theta90;
Int16   sinTheta, cosTheta;

// Voltages
Int16  Vdc;
Int16  Vd, Vq;
Int16  Valfa, Vbeta;
Int16  Va, Vb, Vc;

// PWM Timing computation
Int16  Ta, Tb, Tc;
Int16  Tmax, Tmin;
Int16  Teff, Tzero, Toffset;
Int16  Tao, Tbo, Tco;
//
// PWM technique
pwm_t pwm;

// Sine Table Q15
const Int16 sine[1024] =
{    0,    201,    402,    603,    804,   1005,   1206,   1407,   1607,   1808,   2009,   2210,   2410,   2611,   2811,   3011,
  3211,   3411,   3611,   3811,   4011,   4210,   4409,   4609,   4808,   5006,   5205,   5403,   5602,   5800,   5997,   6195,
  6392,   6589,   6786,   6983,   7179,   7375,   7571,   7766,   7961,   8156,   8351,   8545,   8739,   8933,   9126,   9319,
  9512,   9704,   9896,  10087,  10278,  10469,  10659,  10849,  11039,  11228,  11416,  11605,  11793,  11980,  12167,  12353,
 12539,  12725,  12910,  13094,  13278,  13462,  13645,  13828,  14010,  14191,  14372,  14552,  14732,  14912,  15090,  15269,
 15446,  15623,  15800,  15976,  16151,  16325,  16499,  16673,  16846,  17018,  17189,  17360,  17530,  17700,  17869,  18037,
 18204,  18371,  18537,  18703,  18868,  19032,  19195,  19358,  19519,  19681,  19841,  20001,  20159,  20318,  20475,  20631,
 20787,  20942,  21097,  21250,  21403,  21555,  21706,  21856,  22005,  22154,  22301,  22448,  22594,  22740,  22884,  23027,
 23170,  23312,  23453,  23593,  23732,  23870,  24007,  24144,  24279,  24414,  24547,  24680,  24812,  24943,  25073,  25201,
 25330,  25457,  25583,  25708,  25832,  25955,  26077,  26199,  26319,  26438,  26557,  26674,  26790,  26905,  27020,  27133,
 27245,  27356,  27466,  27576,  27684,  27791,  27897,  28002,  28106,  28208,  28310,  28411,  28511,  28609,  28707,  28803,
 28898,  28993,  29086,  29178,  29269,  29359,  29447,  29535,  29621,  29707,  29791,  29874,  29956,  30037,  30117,  30196,
 30273,  30350,  30425,  30499,  30572,  30644,  30714,  30784,  30852,  30919,  30985,  31050,  31114,  31176,  31237,  31298,
 31357,  31414,  31471,  31526,  31581,  31634,  31685,  31736,  31785,  31834,  31881,  31927,  31971,  32015,  32057,  32098,
 32138,  32176,  32214,  32250,  32285,  32319,  32351,  32383,  32413,  32442,  32469,  32496,  32521,  32545,  32568,  32589,
 32610,  32629,  32647,  32663,  32679,  32693,  32706,  32718,  32728,  32737,  32745,  32752,  32758,  32762,  32765,  32767,
 32767,  32767,  32765,  32762,  32758,  32752,  32745,  32737,  32728,  32718,  32706,  32693,  32679,  32663,  32647,  32629,
 32610,  32589,  32568,  32545,  32521,  32496,  32469,  32442,  32413,  32383,  32351,  32319,  32285,  32250,  32214,  32176,
 32138,  32098,  32057,  32015,  31971,  31927,  31881,  31834,  31785,  31736,  31685,  31634,  31581,  31526,  31471,  31414,
 31357,  31298,  31237,  31176,  31114,  31050,  30985,  30919,  30852,  30784,  30714,  30644,  30572,  30499,  30425,  30350,
 30273,  30196,  30117,  30037,  29956,  29874,  29791,  29707,  29621,  29535,  29447,  29359,  29269,  29178,  29086,  28993,
 28898,  28803,  28707,  28609,  28511,  28411,  28310,  28208,  28106,  28002,  27897,  27791,  27684,  27576,  27466,  27356,
 27245,  27133,  27020,  26905,  26790,  26674,  26557,  26438,  26319,  26199,  26077,  25955,  25832,  25708,  25583,  25457,
 25330,  25201,  25073,  24943,  24812,  24680,  24547,  24414,  24279,  24144,  24007,  23870,  23732,  23593,  23453,  23312,
 23170,  23027,  22884,  22740,  22594,  22448,  22301,  22154,  22005,  21856,  21706,  21555,  21403,  21250,  21097,  20942,
 20787,  20631,  20475,  20318,  20159,  20001,  19841,  19681,  19519,  19358,  19195,  19032,  18868,  18703,  18537,  18371,
 18204,  18037,  17869,  17700,  17530,  17360,  17189,  17018,  16846,  16673,  16499,  16325,  16151,  15976,  15800,  15623,
 15446,  15269,  15090,  14912,  14732,  14552,  14372,  14191,  14010,  13828,  13645,  13462,  13278,  13094,  12910,  12725,
 12539,  12353,  12167,  11980,  11793,  11605,  11416,  11228,  11039,  10849,  10659,  10469,  10278,  10087,   9896,   9704,
  9512,   9319,   9126,   8933,   8739,   8545,   8351,   8156,   7961,   7766,   7571,   7375,   7179,   6983,   6786,   6589,
  6392,   6195,   5997,   5800,   5602,   5403,   5205,   5006,   4808,   4609,   4409,   4210,   4011,   3811,   3611,   3411,
  3211,   3011,   2811,   2611,   2410,   2210,   2009,   1808,   1607,   1407,   1206,   1005,    804,    603,    402,    201,
     0,   -201,   -402,   -603,   -804,  -1005,  -1206,  -1407,  -1607,  -1808,  -2009,  -2210,  -2410,  -2611,  -2811,  -3011,
 -3211,  -3411,  -3611,  -3811,  -4011,  -4210,  -4409,  -4609,  -4808,  -5006,  -5205,  -5403,  -5602,  -5800,  -5997,  -6195,
 -6392,  -6589,  -6786,  -6983,  -7179,  -7375,  -7571,  -7766,  -7961,  -8156,  -8351,  -8545,  -8739,  -8933,  -9126,  -9319,
 -9512,  -9704,  -9896, -10087, -10278, -10469, -10659, -10849, -11039, -11228, -11416, -11605, -11793, -11980, -12167, -12353,
-12539, -12725, -12910, -13094, -13278, -13462, -13645, -13828, -14010, -14191, -14372, -14552, -14732, -14912, -15090, -15269,
-15446, -15623, -15800, -15976, -16151, -16325, -16499, -16673, -16846, -17018, -17189, -17360, -17530, -17700, -17869, -18037,
-18204, -18371, -18537, -18703, -18868, -19032, -19195, -19358, -19519, -19681, -19841, -20001, -20159, -20318, -20475, -20631,
-20787, -20942, -21097, -21250, -21403, -21555, -21706, -21856, -22005, -22154, -22301, -22448, -22594, -22740, -22884, -23027,
-23170, -23312, -23453, -23593, -23732, -23870, -24007, -24144, -24279, -24414, -24547, -24680, -24812, -24943, -25073, -25201,
-25330, -25457, -25583, -25708, -25832, -25955, -26077, -26199, -26319, -26438, -26557, -26674, -26790, -26905, -27020, -27133,
-27245, -27356, -27466, -27576, -27684, -27791, -27897, -28002, -28106, -28208, -28310, -28411, -28511, -28609, -28707, -28803,
-28898, -28993, -29086, -29178, -29269, -29359, -29447, -29535, -29621, -29707, -29791, -29874, -29956, -30037, -30117, -30196,
-30273, -30350, -30425, -30499, -30572, -30644, -30714, -30784, -30852, -30919, -30985, -31050, -31114, -31176, -31237, -31298,
-31357, -31414, -31471, -31526, -31581, -31634, -31685, -31736, -31785, -31834, -31881, -31927, -31971, -32015, -32057, -32098,
-32138, -32176, -32214, -32250, -32285, -32319, -32351, -32383, -32413, -32442, -32469, -32496, -32521, -32545, -32568, -32589,
-32610, -32629, -32647, -32663, -32679, -32693, -32706, -32718, -32728, -32737, -32745, -32752, -32758, -32762, -32765, -32767,
-32767, -32767, -32765, -32762, -32758, -32752, -32745, -32737, -32728, -32718, -32706, -32693, -32679, -32663, -32647, -32629,
-32610, -32589, -32568, -32545, -32521, -32496, -32469, -32442, -32413, -32383, -32351, -32319, -32285, -32250, -32214, -32176,
-32138, -32098, -32057, -32015, -31971, -31927, -31881, -31834, -31785, -31736, -31685, -31634, -31581, -31526, -31471, -31414,
-31357, -31298, -31237, -31176, -31114, -31050, -30985, -30919, -30852, -30784, -30714, -30644, -30572, -30499, -30425, -30350,
-30273, -30196, -30117, -30037, -29956, -29874, -29791, -29707, -29621, -29535, -29447, -29359, -29269, -29178, -29086, -28993,
-28898, -28803, -28707, -28609, -28511, -28411, -28310, -28208, -28106, -28002, -27897, -27791, -27684, -27576, -27466, -27356,
-27245, -27133, -27020, -26905, -26790, -26674, -26557, -26438, -26319, -26199, -26077, -25955, -25832, -25708, -25583, -25457,
-25330, -25201, -25073, -24943, -24812, -24680, -24547, -24414, -24279, -24144, -24007, -23870, -23732, -23593, -23453, -23312,
-23170, -23027, -22884, -22740, -22594, -22448, -22301, -22154, -22005, -21856, -21706, -21555, -21403, -21250, -21097, -20942,
-20787, -20631, -20475, -20318, -20159, -20001, -19841, -19681, -19519, -19358, -19195, -19032, -18868, -18703, -18537, -18371,
-18204, -18037, -17869, -17700, -17530, -17360, -17189, -17018, -16846, -16673, -16499, -16325, -16151, -15976, -15800, -15623,
-15446, -15269, -15090, -14912, -14732, -14552, -14372, -14191, -14010, -13828, -13645, -13462, -13278, -13094, -12910, -12725,
-12539, -12353, -12167, -11980, -11793, -11605, -11416, -11228, -11039, -10849, -10659, -10469, -10278, -10087,  -9896,  -9704,
 -9512,  -9319,  -9126,  -8933,  -8739,  -8545,  -8351,  -8156,  -7961,  -7766,  -7571,  -7375,  -7179,  -6983,  -6786,  -6589,
 -6392,  -6195,  -5997,  -5800,  -5602,  -5403,  -5205,  -5006,  -4808,  -4609,  -4409,  -4210,  -4011,  -3811,  -3611,  -3411,
 -3211,  -3011,  -2811,  -2611,  -2410,  -2210,  -2009,  -1808,  -1607,  -1407,  -1206,  -1005,   -804,   -603,   -402,   -201};



//---------------------------------------------------------------------------
// InitVars:
//---------------------------------------------------------------------------
// This function initializes the Global Variables to a known (default) state.
void InitVars(void)
{
    // Initialize System Variables
    freq_set = Q8(F_RATED);
    Vdc      = Q6(VDC);

    // Initialize State Variables
    freq_state = 0;
    thetaState = 0;

    // Initialize PWM technique
    pwm = SINE;
}
